
' ---------------------------------------------------------------------------
' Demo zur Benutzung des ESCI der Open-Midi, mit 8 Byte Empfangsbuffer
' von Dietmar Harlos am 27. Juni 2006
' ---------------------------------------------------------------------------

' RxD liegt am Pin 7 vom PDIP-14-Gehaeuse, entspricht PORT[13]
' TxD liegt am Pin 6 vom PDIP-14-Gehaeuse, entspricht PORT[14]

' TxD wird vom Kontroller in der Push/Pull-Betriebsart angesprochen.

' ---------------------------------------------------------------------------

INCLUDE "omid.def"              'Definition fuer Open-Midi einbinden

DEFINE a BYTE                   'ein paar temporaere Variablen
DEFINE ^p BYTE

' Speicher fuer den ESCI-Empfangsbuffer

DEFINE ESCIBUFPTR  BYTE [162]   'Kombinierter Zeiger fuer ESCI
DEFINE ESCIBUFFER0 BYTE [163]
DEFINE ESCIBUFFER1 BYTE [164]   'Die 8 Bytes des Buffers muessen
DEFINE ESCIBUFFER2 BYTE [165]   'hintereinander liegen
DEFINE ESCIBUFFER3 BYTE [166]
DEFINE ESCIBUFFER4 BYTE [167]
DEFINE ESCIBUFFER5 BYTE [168]
DEFINE ESCIBUFFER6 BYTE [169]
DEFINE ESCIBUFFER7 BYTE [170]

' ---------------------------------------------------------------------------

INCLUDE "omidesci.iia"          'Routinen fuer die ESCI einbinden

' ---------------------------------------------------------------------------

#main                           'Das Hauptprogramm

UIREsciR=ON                     'IIAR in den ESCI-Receive-Interrupt einbinden

esciinit                        'ESCI-Modul des Kontrollers initialisieren

WHILE TRUE

  FOR p=161 TO 169              'Dump der Buffer-Daten
    PRINTNUM @p
  NEXT p
  
  esciPUT " "
  
  PRINTNUM esciRXD
  
  esciPUT " "

  IF esciRXD THEN               'Zeichen aus Buffer holen, sofern vorhanden
    esciPUT esciGET
    esciPUT " "
  END IF
  
  PAUSE 100                     'Waehrend der Pause kann der Anwender bis
  esciPUT 13                    'zu 8 Zeichen im Terminalprogramm eingeben.
  esciPUT 10                    'Sie werden empfangen und gespeichert.

WEND

END

' ---------------------------------------------------------------------------

' Simple Routine zur Ausgabe von Dezimalzahlen

PROC PRINTNUM(a)
  esciPUT " "
  esciPUT a/100+"0"
  esciPUT a/10 MOD 10+"0"
  esciPUT a MOD 10+"0"
RETURN

' ---------------------------------------------------------------------------

INCLUDE "omfwia.pro"            ' Firmwareroutinen einbinden







